//+------------------------------------------------------------------+
//|                                           Petit_pips_tsd_002.mq4 |
//|                                                         BigBoppa |
//|                                             BigBoppa2de@yahoo.de |
//+------------------------------------------------------------------+
#property copyright "BigBoppa"
#property link      "BigBoppa2de@yahoo.de"

#include <WinUser32.mqh>


extern int           TimeToTrade1       = 1700; // 9999 = no 1st time
extern int           TimeToTrade2       = 2100; // 9999 = no 2nd time

extern int           TakeProfit        = 6;  
extern int           StopLoss          = 100;
extern int           Slippage          = 0;

extern double        MA1_period        = 8;
extern double        MA2_period        = 17;
extern double        MA3_period        = 20;
extern double        MA4_period        = 29;
extern double        MA5_period        = 37;
extern double        RSI_period        = 28;
extern double        RSI_Limit         = 5;
extern int           RSI_Over          = 30;
extern double        RSI_diff          = 0.5;

extern bool          Play_Sound        = true;
extern bool          MoneyManagement   = true;
extern double        minLots           = 0.01;
extern double        maxLots           = 50;
extern int           Risk_percent      = 25;


double   SMA1,
         SMA2,
         SMA3,
         SMA4,
         SMA5,
         RSI1,
         TakeP,
         StopL,
         Lots;
         
int      HourToTrade1, 
         MinuteToTrade1,
         HourToTrade2, 
         MinuteToTrade2,
         ticket,
         magic;        
         
bool     SMA_buy,
         SMA_sell,
         RSI_buy,
         RSI_sell,
         Trade_Enable,
         Time_Open,
         Time_Done;
         
string   OpenSound                      ="news.wav",
         ErrorSound                     ="alert.wav",
         CloseSound                     ="alert2.wav",
         _TimeToTrade1,
         _TimeToTrade2;
         

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  
  _TimeToTrade1=(TimeToTrade1);
  _TimeToTrade2=(TimeToTrade2);

//----
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") { magic = 469301; }
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") { magic = 469302; }
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") { magic = 469303; }
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") { magic = 469304; }
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") { magic = 469305; }
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") { magic = 469306; }
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") { magic = 469307; }
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") { magic = 469308; }
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") { magic = 469309; }
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") { magic = 469310; }
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") { magic = 469311; }
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") { magic = 469312; }
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") { magic = 469313; }
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") { magic = 469314; }
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") { magic = 469315; }
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") { magic = 469316; }
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") { magic = 469317; }
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") { magic = 469318; }
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") { magic = 469319; }
   if (magic == 0) { magic = 469399; }
      
   if(TakeProfit==0)TakeProfit=10;
   Trade_Enable=true;
  
      HourToTrade1=StrToInteger(StringSubstr(_TimeToTrade1,0,2));
      MinuteToTrade1=StrToInteger(StringSubstr(_TimeToTrade1,2,2));
/*      if (HourToTrade1<0 || HourToTrade1>23 || MinuteToTrade1<0 || MinuteToTrade1>59)
         {
         MessageBox( "Trade Time Error!",NULL, MB_OK);
         Trade_Enable=false;
         }

*/

      
      HourToTrade2=StrToInteger(StringSubstr(_TimeToTrade2,0,2));
      MinuteToTrade2=StrToInteger(StringSubstr(_TimeToTrade2,2,2));      
/*         if (HourToTrade2<0 || HourToTrade2>23 || MinuteToTrade2<0 || MinuteToTrade2>59)
         {
         MessageBox( "Trade Time Error!",NULL, MB_OK);
         Trade_Enable=false;
         }
*/
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert calls                                                     |
//+------------------------------------------------------------------+  

void Call_SMA()
{
   double _Price=(Bid+Ask)/2;
   SMA1=iMA(NULL,0,MA1_period,0,0,PRICE_MEDIAN,0);
   SMA2=iMA(NULL,0,MA2_period,0,0,PRICE_MEDIAN,0);
   SMA3=iMA(NULL,0,MA3_period,0,0,PRICE_MEDIAN,0);
   SMA4=iMA(NULL,0,MA4_period,0,0,PRICE_MEDIAN,0);
   SMA5=iMA(NULL,0,MA5_period,0,0,PRICE_MEDIAN,0);
  
   if(SMA1<_Price && SMA1>SMA2 && SMA2>SMA3 && SMA3>SMA4 && SMA4>SMA5)
      SMA_buy=true;
   else
      SMA_buy=false;
      
   if(SMA1>_Price && SMA1<SMA2 && SMA2<SMA3 && SMA3<SMA4 && SMA4<SMA5)

      SMA_sell=true;
   else
      SMA_sell=false;
   
   return(0);      
}  
//+------------------------------------------------------------------+  

void Call_RSI()
{
   RSI1=iRSI(NULL,0,RSI_period,PRICE_MEDIAN,0);
   double RSI2=iRSI(NULL,0,RSI_period,PRICE_MEDIAN,1);


   if(RSI1>50+RSI_Limit  && RSI1>RSI2+RSI_diff  && RSI1<100-RSI_Over)
      RSI_buy=true;
   else
      RSI_buy=false;
      
   if(RSI1<50-RSI_Limit  && RSI1<RSI2-RSI_diff  && RSI1>RSI_Over)
      RSI_sell=true;
   else
      RSI_sell=false;
   return(0);           
}
//+------------------------------------------------------------------+  

void Call_Time()
{
         if ((Hour()==HourToTrade1 && Minute()==MinuteToTrade1)||(Hour()==HourToTrade2 && Minute()==MinuteToTrade2))
            {

      
            if (!Time_Done)
               {
               Time_Open=true;
               Time_Done=true;
               }
            else
               Time_Open=false;
            }
         else
            {
            Time_Open=false;
            Time_Done=false;
            }
            
   return(0);           
}
//+------------------------------------------------------------------+ 

void Call_MM()
{
   if (MoneyManagement==true)Lots=AccountEquity()/100000*Risk_percent;
   else Lots=minLots;

   Lots=MathMin(maxLots,MathMax(minLots,Lots));
   if(minLots<0.1) 
     Lots=NormalizeDouble(Lots,2);               //   1k
   else
     {
     if(minLots<1) Lots=NormalizeDouble(Lots,1); //  10k
     else          Lots=NormalizeDouble(Lots,0); // 100k
     }
     
   return(0);


}

//+------------------------------------------------------------------+ 


void Call_Trade()
{  
   if (Trade_Enable && Time_Open && RSI_buy && SMA_buy)
      {
      TakeP=Ask+TakeProfit*Point;
      if(StopLoss>0) StopL=Ask-StopLoss  *Point;
      else StopL=0;
      
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopL,TakeP,"Buy",magic,0,Blue); 
      if (ticket>0)
         {
         if (Play_Sound)PlaySound(OpenSound);
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Buy order opened : ",OrderOpenPrice(),"  Free Margin = ", AccountFreeMargin(),"  TakeProfit:",TakeP," StopLoss:",StopL);
         }
      else
         {
         PlaySound(ErrorSound);
         Print("Error opening Buy order : ",GetLastError()); 
         }
      }

   if (Trade_Enable && Time_Open && RSI_sell && SMA_sell)
      {
      TakeP=Bid-TakeProfit*Point;
      if(StopLoss>0)StopL=Bid+StopLoss  *Point;
      else StopL=0;
      
      
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopL,TakeP,"Sell",magic,0,Red); 
      if (ticket>0)
         {
         if (Play_Sound)PlaySound(OpenSound);
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Sell order opened : ",OrderOpenPrice(),"  Free Margin = ", AccountFreeMargin(),"  TakeProfit:",TakeP," StopLoss:",StopL);
         }
      else
         {
         PlaySound(ErrorSound);
         Print("Error opening Sell order : ",GetLastError()); 
         }
      } 
      return(0);           
     
}  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
Call_SMA();
Call_RSI();
Call_Time();
Call_MM();
Call_Trade();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

